package services

import (
	"PaymentCenter/app/constants/errorcode"
	"PaymentCenter/app/data"
	"PaymentCenter/app/http/entities/front"
	"PaymentCenter/app/models/merchantmodel"
)

type WebPay struct {
	WebPayReqs *front.PayWebReqs
	AppCheck   *AppCheck
	Order      *data.OrderRepo
	PayCode    int
}

func NewWebPay(resp *front.PayWebReqs, appCheck *AppCheck) *WebPay {
	if appCheck == nil {
		appCheck = AppGetAndCheck(&AppCheck{
			AppId: resp.AppId,
			Code:  errorcode.Success,
		})
	}
	return &WebPay{
		WebPayReqs: resp,
		AppCheck:   appCheck,
		PayCode:    appCheck.Code,
	}
}

func (w *WebPay) AddPayLog() {
	w.PayCode = GetAndCheckMerchant(&merchantmodel.Merchant{Id: w.AppCheck.App.MerchantId}, nil)
}

func (w *WebPay) CheckMerchant() {
	w.PayCode = GetAndCheckMerchant(&merchantmodel.Merchant{Id: w.AppCheck.App.MerchantId}, nil)
}

func (w *WebPay) CheckPayChannel() {
	w.PayCode = GetAndCheckMerchant(&merchantmodel.Merchant{Id: w.AppCheck.App.MerchantId}, nil)
}
